<?php

use Shaarli\Config\ConfigManager;

function auto_tag_plugin_init(ConfigManager $conf)
{
    // Configure keywords and tags based on provided rules
    $conf->setEmpty('plugins.AUTO_TAG_KEYWORDS', [
        'accessibility,web development,web design,html,css' => 'web-development',
        'accounting' => 'accounting',
        'addict,drugs,cigarettes,bonbons,dopamine,sucre,nicotine,hooked,drogues' => 'addiction',
        'adhd,tdah' => 'adhd',
        'alternative,compatible,migrated,migration' => 'alternatives',
        'ads,spam' => 'ads',
        'anxi,burnout,meditat,cardio' => 'health-and-wellness',
        'architecture' => "architecture",
        'archive,archiving' => 'archiving,archives',
        'art' => 'culture',
        'ask hn,news.ycombinator.com/item,reddit.com/r/' => 'debate',
        'audio' => 'audio',
        'autism,autist' => 'autism',
        'automation,automate,automatic,scripting,terminal,shell script' => 'scripting,automation',
        'beauty,imperfection' => 'beauty,imperfection',
        'belgian,belgium,belgique' => 'belgium',
        'astuce,best practices,checklist,guide,how-to,how to,deep dive,dive into,tips,optimize,optimization,comment,étapes,tutorial,tutoriel,how do I' => 'guides-and-tips',
        'board game,board games,boardgame' => 'board-games,geek,may-play',
        'bookmarks' => 'bookmarks-management',
        'browsers' => 'web-browsers',
        'books,livre,livre,quatrième de couverture,roman,novel,reading-list' => 'reading-and-literature,may-read,inspiration,culture',
        'robots.txt,bots,spam,crawling,ddos' => 'spam',
        'bruxelles,brussels' => 'brussels',
        'calm tech,calmness,calm' => 'calm-tech',
        'cheatsheet,cheat sheet,cheat-sheet' => 'cheatsheet,guides-and-tips',
        'cleaning,nettoyage' => 'cleaning',
        'cloud,aws,amazon,cloudron' => 'cloud',
        'cloudron' => 'cloudron,hosting',
        '(comic),-comic-,comics' => 'comics,reading-and-literature,may-read,culture,humor',
        'comparison,comparer, vs ,versus' => 'comparison',
        'communicate,communication,messaging,messenger,gmail' => 'communication',
        'complex,impossible to solve,complicated,very difficult' => 'complexity, its-complicated',
        'configure,configuration' => 'configuration',
        'database,RDS' => 'databases',
        'data collection' => 'data-collection',
        'data transfer' => 'data-portability',
        'debug,troubleshoot,diagnose,problem,solv,troubleshoot' => 'problem-solving,guides-and-tips,debugging',
        'degoogl' => 'freedom',
        'design' => 'design',
        'development workflow,devex' => 'devex',
        'disk' => 'storage',
        'distraction,procrastin' => 'procrastination',
        'diy,self-host,héberger soi-même,my personal' => 'diy',
        'dns,network,tcp,wireshark' => 'network',
        'docker,docker-compose,docker compose,container,containers,k8s,eks,kubernetes,minikube,k3s,helm,openshift' => 'container-technology,devops',
        'documentation,docs,document' => 'documentation',
        'ses droits,legally' => 'legal',
        'elixir,python,pip,rust,golang,programming,developer,software development,developers' => 'software-development',
        'emulator,emulation' => 'emulation',
        'entrepreneurship,entrepreneurs' => 'business',
        'espresso,coffee' => 'coffee',
        'ethic,ethique' => 'ethics',
        'explor,going deep' => 'discovery',
        'fediverse,unsafe' => 'privacy-and-security,freedom,social-media',
        'libre' => 'freedom',
        'logiciel libre,free software,logiciel gratuit,free to use' => 'free-software',
        'from home,remote work,work remote' => 'remote-work',
        'big-tech,gafam,degoogling,degoogle' => 'big-tech',
        'game,jeu vidéo,game dev,jeux' => 'games,geek,culture,may-play',
        'gamedev,building game' => 'gamedev,games,geek,culture',
        'gender,homosexualité,hétérosexualité,les sexes,caractères sexuels' => 'gender',
        'gratuit,free' => 'free',
        'gitops,gitlab,github actions,devops,SRE,ci/cd,platform-engineering,ci pipeline,application deployment,dagger,renovatebot,dependabot,continuous integration,site reliability eng' => 'devops,automation',
        'git,gitlab,jujutsu,pijul,mercurial,svn,version control' => 'version-control',
        'gpt,chatgpt,llm,llms,artificial intelligence,intelligence artificielle,l\'ia' => 'ai',
        'hacking' => 'hacking',
        'health,healthy,nutrition,food,alimentation,nourriture' => 'health-and-wellness,food',
        'humans,humains' => 'humans',
        'humor,humour' => 'humor',
        'inspiration,creativity,creative' => 'inspiration',
        'leadership,staff engineering' => 'leadership',
        'lambic,gueuze,beer,bière' => 'beer-and-brewing',
        'linux,ubuntu,debian,linux windows macos' => 'os',
        'list,index of,awesome,installation,GitHub - ' => 'list,discovery,tools-and-resources',
        'low-tech,low tech' => 'low-tech',
        'markdown' => 'markdown,text-files,plaintext,formats',
        'merdification,enshittif,AI-generated,crapification,decline in quality' => 'enshittification',
        'monitoring,metrics,to monitor' => 'monitoring,metrics',
        'movie,cinéma,cinema,film' => 'movies,culture,geek',
        'music,spotify,radios,webradios,soundtrack,bande originale,musique' => 'music',
        'newsletter' => 'newsletter,news,may-subscribe',
        'nostalg' => 'nostalgia',
        'obsidian,note taking,note-taking,knowledge manag' => 'knowledge-management,note-taking',
        'open-source,open source' => 'open-source,free',
        'optimize,optimization,speed up,an efficient' => 'optimization',
        'organize,organise,planning,prioritize,priorities,priority,tasks,project,focus,productivity,productive,gestion de tâches,ticktick' => 'organizing,productivity-and-management',
        'philosoph' => 'philosophy',
        'photography' => 'photography,photos',
        'podcast' => 'podcast',
        'ego,narciss' => 'psychology,ego',
        'psycholog' => 'psychology',
        'voting,politic,politique' => 'politics',
        'python' => 'python,software-development,code',
        'privatebin,secret' => 'secrets',
        'problem,solv,trouble' => 'problem-solving',
        'programming languages' => 'code,computer-languages',
        'publishing' => 'publishing',
        'quality' => 'quality',
        'recommandations,recommendation' => 'recommandations,recommendations',
        'recycling,sustainab,green web,climate' => 'ecology',
        'religion,chrétiens,bible,coran,islam,musulmans,croyants,athée,la foi,église' => 'religion',
        'reviews,critique' => 'reviews',
        'rss,rss feed,miniflux,web reader' => 'content-aggregation,content-curation',
        'ruby,rails app' => 'ruby,software-development,code',
        'science' => 'science',
        'scripting,jq,curl,wget' => 'scripting',
        'search engine' => 'search-engines',
        'security,permission,sécurité,secure,privacy,private,degoogl,gdpr,data protection,online tracking,user profiling,anonymo,anonymi,surveillance,malware,spyware,decentrali,secrets,privacy matters,vpn,passkey' => 'privacy-and-security',
        'simplicity,minimal,less,declutter,stopped using,simple,simplif,reduction in,fewer,no longer needed' => 'minimalism',
        'small web,indie web,indieweb' => 'small-web',
        'smartphone,android,mobile,phone,téléphone' => 'mobile',
        'snippet' => 'code',
        'static site,static-site' => 'static-site,static-web',
        'teamwork,collaborat,équipe,cooperat,coordinat' => 'collaboration',
        'technology' => 'technology',
        'template' => 'template',
        'terminal' => 'terminal,tools-and-resources',
        'test' => 'testing',
        'text-based,plaintext,markup language,markdown,plain text' => 'plaintext,minimalism,formats,text-files',
        'time to update,maintainers,tech-debt,legacy code,long term software' => 'maintenance,tech-debt',
        'to do,to-do' => 'todo',
        'tool,resources,a script,outil,a collection,a catalog,awesome list,links' => 'tools-and-resources',
        'training,course,conference talk,learning,homeschool,expert,specializ,tacit knowledge,tribal knowledge' => 'education',
        '.txt,text-based' => 'text-files',
        'ui' => 'ui',
        'ux,the experience of,usable,uxer,user experience' => 'ux',
        'vps' => 'cloud,vps,hosting',
        'web archive,web archiving,save any website,bookmarks,wayback machine,archive.org,archivebox' => 'web-archiving',
        'wordpress,personal website,blog roll,blogroll,blogosphere,webring,digital garden,to blog' => 'blogging,writing,publishing,culture',
        'work' => 'work',
        'youtube.com,invidious,peertube,watch?v' => 'to-watch,video',
        'zoemp' => 'zoemp'
    ]);
}

function fetch_page_content($url)
{
    $htmlContent = @file_get_contents($url);
    if ($htmlContent === false) {
        return '';
    }

    $htmlContent = preg_replace('/<(script|style|head|noscript)[^>]*>.*?<\/\1>/is', '', $htmlContent);
    return strip_tags($htmlContent);
}


function calculate_tags(array $keywordsToTags, array $searchContents): array
{
    $contextWeights = [
        'title' => 3,
        'url' => 3,
        'description' => 3,
        'existing' => 3,
        'content' => 1
    ];

    $tagScores = [];

    foreach ($keywordsToTags as $keywords => $tags) {
        $keywordList = explode(',', $keywords);
        foreach ($keywordList as $keyword) {
            $keyword = preg_quote(trim($keyword), '/');
            $regex = '/\b' . $keyword . '\b/i';

            foreach ($searchContents as $context => $content) {
                if (preg_match($regex, $content)) {
                    $tagList = explode(',', $tags);
                    foreach ($tagList as $tag) {
                        $tag = trim($tag);
                        if (!isset($tagScores[$tag])) {
                            $tagScores[$tag] = 0;
                        }
                        $tagScores[$tag] += $contextWeights[$context];
                    }
                }
            }
        }
    }

    return $tagScores;
}

function filter_and_limit_tags(array $tagScores, int $minScore = 2, int $maxTags = 7): array
{
    // Filter tags with a score greater than or equal to the minimum required
    $filteredTags = array_filter($tagScores, function ($score) use ($minScore) {
        return $score >= $minScore;
    });

    // Sort tags by descending score
    arsort($filteredTags);

    // Limit the number of tags to the maximum allowed
    return array_slice(array_keys($filteredTags), 0, $maxTags);
}

function apply_auto_tags(array $data, ConfigManager $conf): array
{
    if (empty($data['link']['url'])) {
        return $data;
    }
    $keywordsToTags = $conf->get('plugins.AUTO_TAG_KEYWORDS', []);
    $pageContent = fetch_page_content($data['link']['url']);

    $searchContents = [
        'title' => $data['link']['title'],
        'url' => $data['link']['url'],
        'description' => $data['link']['description'] ?? '',
        'existing' => implode(' ', explode(' ', $data['link']['tags'] ?? '')),
        'content' => $pageContent
    ];

    // Calculate scores for each tag
    $tagScores = calculate_tags($keywordsToTags, $searchContents);

    // Filter and limit tags
    $tagsToAdd = filter_and_limit_tags($tagScores);

    $tagsToAdd[] = 'auto-tagged'; // Added a fixed tag
    $existingTags = array_map('trim', explode(' ', $data['link']['tags']));
    $tagsToAdd = array_map('trim', $tagsToAdd);

    $data['link']['tags'] = trim(implode(' ', array_filter(array_unique(array_merge($existingTags, $tagsToAdd)))));

    return $data;
}

function hook_auto_tag_plugin_render_editlink(array $data, ConfigManager $conf): array
{
    if (!$data['link_is_new']) {
        //return $data; // Do not reapply for non-new links
    }

    return apply_auto_tags($data, $conf);
}

function hook_auto_tag_plugin_save_link(array $data, ConfigManager $conf): array
{
    return apply_auto_tags($data, $conf);
}